import { IOptions } from "./stringify";
declare type ActionType = "CREATE" | "UPDATE" | "DELETE" | "ASSOCIATE" | "DISASSOCIATE" | "RETRIEVE" | "RETRIEVE_MULTIPLE";
declare class BatchRequest {
    private batchId;
    private payload;
    private transaction;
    private fetchCall;
    private fetchCallId;
    private changeSetId;
    private req;
    private transactionId;
    private baseUrl;
    /**
     *
     * @param baseUrl available from window.context.page.getClientUrl() + "/api/data/v9.1";
     */
    constructor(baseUrl: string);
    addTransaction: ({ entityId, entityName, action, payload, relation, }: {
        entityName: string;
        action: ActionType;
        entityId?: string;
        payload?: Record<string, string | number>;
        relation?: {
            relationName: string;
            entityName: string;
            entityId: string;
        };
    }) => void;
    addFetchCall: (entityName: string, options: IOptions) => void;
    done: () => Promise<unknown>;
}
export default BatchRequest;
